//////////////////////////////////////////////////////////////////////////
//
// CPAutomaton.cpp
// Provides A1_Main definition 
//
//////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "CentralPoint.h"
#include "CPAutomaton.h"

namespace central_point
{

A1_Main::A1_Main( CCentralPoint& cp ) 
   : Base   ( main_automaton::S_1_STANDBY )
   , object_( cp )
{
}

void A1_Main::CalcState( OptState& state )
{
   using namespace main_automaton ;

   switch( GetState())
   {
   case S_1_STANDBY:

      if( e(1) && object_.x1())
      {
         Trace( L"Transition 1" ) ;
         state.reset( S_2_STARTING ) ;
      }

      break ;
   case S_2_STARTING:

      if ( object_.x2())
      {
         Trace( L"Transition 1" ) ;
         state.reset( S_3_READYFORUSERS ) ;
      }
      else
      {
         Trace( L"Transition 2" ) ;
         state.reset( S_1_STANDBY ) ;
      }

      break ;
   case S_3_READYFORUSERS:

      if( e( 2 ))
      {
         Trace( L"Transition 1" ) ;
         object_.z1() ;
         state.reset( S_3_READYFORUSERS ) ;
      }
      else if( e( 4 ) && !object_.x3()) 
      {
         Trace( L"Transition 2" ) ;
         object_.z2() ;
         state.reset( S_1_STANDBY ) ;
      }
      else if( e( 4 ) && object_.x3())
      {
         Trace( L"Transition 3" ) ;
         object_.z3() ;            
         state.reset( S_4_STOPPING ) ;
      }
      else if( e( 3 ))
      {
         Trace( L"Transition 4" ) ;
         object_.z2() ;
         state.reset( S_1_STANDBY ) ;
      }
      else if ( e( 6 ))
      {
         Trace( L"Transition 5" ) ;
         object_.z5() ;
         state.reset( S_3_READYFORUSERS ) ;
      }

      break ;
   case S_4_STOPPING:

      if ( e( 5 ))
      {
         state.reset( S_1_STANDBY ) ;
      }
      else if ( e( 6 ))
      {
         Trace( L"Transition 2" ) ;
         object_.z5() ;
         state.reset( S_4_STOPPING ) ;
      }

      break ;
   }
}

void A1_Main::OnStateChanged()
{
   using namespace main_automaton ;

   switch( GetState())
   {
   case S_2_STARTING:

      object_.z4() ;
   
      break ;
   }
}

} // namespace central point 