//////////////////////////////////////////////////////////////////////////
//
// CPAutomaton.h 
// Provides A1_Main declaration, see CPAutomaton.cpp for definition 
//
//////////////////////////////////////////////////////////////////////////

#pragma once 
#include "BaseAutomaton.h"

//////////////////////////////////////////////////////////////////////////
//
// Central Point Automaton 
//

class CCenrtalPoint ;

namespace central_point 
{

namespace main_automaton
{

enum State
{
   S_1_STANDBY        = 1 , // initial
   S_2_STARTING           , 
   S_3_READYFORUSERS      , 
   S_4_STOPPING           ,
} ;

} // main_automaton 

enum Event
{
   E_1_START         = 1,
   E_2_NEWUSER          ,
   E_3_STOPFORCE        ,
   E_4_STOPNONFORCE     ,
   E_5_LASTDROPPED      ,
   E_6_USERDISCONNECTED 
} ;

struct A1_Main
   : public BaseAutomaton< main_automaton::State, Event >
{  
   typedef BaseAutomaton< main_automaton::State, Event > Base ;

   A1_Main ( CCentralPoint& cp ) ;  
   LPCWSTR GetPrefix() const { return L"CentralPoint Automaton: " ; }

   void    SetTracer( ITracer* tracer ) { TracerImpl::Init( tracer ) ; }
   
private:
   void CalcState     ( OptState& state ) ;
   void OnStateChanged()                  ;

private:
   CCentralPoint& object_ ;
};

} // central_point
