#pragma once 
#include "transport.h"

struct DataConnection
   : public TSockStream
{
   DataConnection( user_site::A2_MainAutomaton& automaton )
      : TSockStream( AF_INET, IPPROTO_TCP )
      , automaton_ ( automaton )
   {
   } 

   void ConnectChanged()
   {
      if( connected )
         automaton_.ProcessEvent( user_site::E_30_DC_OPENED ) ;
      else 
         automaton_.ProcessEvent( user_site::E_31_DC_ERROR ) ;
   }

   void SocketError( int code )
   {
      automaton_.ProcessEvent( user_site::E_31_DC_ERROR ) ;
      TSockPoint::SocketError( code ) ;
   }

   void AllDataSended()
   {
      automaton_.ProcessEvent( user_site::E_34_ALLTRANSFERED ) ;
   }

   void Receive(int size, const void * data, const TPointName * from ){}

private:
   user_site::A2_MainAutomaton& automaton_ ;
};