//////////////////////////////////////////////////////////////////////////
//
// RSAutomaton.h 
// Provides A5_RemoteServer declaration, see RSAutomaton.cpp for definition 
//
//////////////////////////////////////////////////////////////////////////

#pragma once 
#include "BaseAutomaton.h"

//////////////////////////////////////////////////////////////////////////
//
// Remote server automaton 
//

class RemoteServer ;

namespace remote_server
{

   namespace main_automaton
   {
      enum State
      {
         S_1_CONNECT       = 1,
         S_2_WAIT4GREETINGS   ,
         S_3_PROC_USER        ,
         S_4_PROC_PASS        ,
         S_5_READY4RETR       ,
         S_6_SETPARAMS        ,  
         S_7_TRANSFERING      ,
         S_8_CLOSE            

      } ;
   } // main_automaton 

   enum Event
   {
      E_1_REPLY            = 1,
      E_2_REPLY               ,
      E_3_REPLY               ,
      E_4_REPLY               ,
      E_5_REPLY               ,
      E_6_CONNECTIONERROR     ,   
      E_7_CONNECTED           ,
      E_8_RETRIEVE            ,
      E_9_ABORT         
   } ;

   struct A5_RemoteServer
      : public BaseAutomaton< main_automaton::State, Event >
   {
      typedef BaseAutomaton< main_automaton::State, Event > Base ;

      A5_RemoteServer( RemoteServer& rs ) ;
      LPCWSTR GetPrefix() const { return L"Remote Server Automaton: " ; }

   private:
      void CalcState     ( OptState& state ) ;
      void OnStateChanged() ;

   private:
      RemoteServer&  object_ ;
   };

} // namespace remote_server 


