#pragma once 
#include "Transfer.h"
#include "Telnet.h"
#include "RSAutomaton.h"

class UserSite ;

class RemoteServer
   : TracerImpl 
   , private TelnetReceiver
{
public:

   RemoteServer ( UserSite& us, ITracerManager* tracerMng, TINETAddr const& addr, 
                  LPCSTR user, LPCSTR pass, LPCSTR path ) ;
   
   void Download( LPCSTR path ) ;
   void Abort() ; // proceed abort ( from control connection of user site )

// automaton routine 
   BOOL x1() const ; // aborted
   BOOL x2() const ; // need PORT
   BOOL x3() const ; // need TYPE
   BOOL x4() const ; // need STRU 
   BOOL x5() const ; // need MODE 
   BOOL x6() const ; // all pending params sent 

   void z1() ; // connect to server
   void z2() ; // process retrieving start procedure failure   
   void z3() ; // send USER 
   void z4() ; // send PASS
   void z5() ; // send PORT 
   void z6() ; // send TYPE 
   void z7() ; // send STRU 
   void z8() ; // send MODE 
   void z9() ; // parameter sent notification 
   void z10() ; // send RETR  
   void z11() ; // post e8 event 
   void z12() ; // forward retrieving start 
   void z13() ; // forward retrieving stop 
   void z14() ; // drop server connection 
   void z15() ; // notification about abnormal retrieving abort
   void z16() ; // proceed retrieving procedure failure 
   void z17() ; // notify about successful operation 
   void z18() ; // send ABOR 

// for tracer 
public:
   LPCWSTR GetPrefix() const { return L"Remote Server: " ; }

// TelnetReceiver
private:
   void FragmentReceived(int size, const void * data ) ;
   void ConnectChanged  () ;

   void SendCommand     ( LPCSTR cmd ) ;

private:
   remote_server::A5_RemoteServer auto_ ;

private:
   TransferParamters params_ ;
   int               pendingSuccessEchos_ ;
   std::string       path_   ;

   BOOL        aborted_    ;
   std::string lastReply_  ;
   UserSite&   us_         ;

   TINETAddr   serverAddr_ ;
   std::string user_       ;
   std::string pass_       ;
};