#pragma once 

class TelnetReceiver 
   : public TFragmentStream
{
protected:
   TelnetReceiver() 
      : TFragmentStream( AF_INET, IPPROTO_TCP )
   {
   }
   
   TelnetReceiver( SOCKET const& sock )
      : TFragmentStream( sock )
   {
   }


   void Receive( int size, const void * data, const TPointName * from ) 
   {
      const short clrf = 0x0a0d ;

      char * p = (char*)data ;
      char * e = p + size ;
      while ( p < e )
      {
         if ( clrf != *(short*)p )
         {
            ATLASSERT( len < sz ) ;
            memcpy ( buf + len, p, 1 ) ;
            ++ p ;
            ++ len ;
         }
         else
         {
            FragmentReceived ( len, buf ) ;
            len = 0 ;
            p += 2 ;
         }
      }
   }

private:
   void Error ( int code ) const 
   {
      __TRACE ( L"Socket_Error: Error %d on sock %d", code, sock ) ; 
   }
};