#pragma once 

struct TransferParamters
{
   char        type ;
   char        stru ;
   char        mode ;
   TINETAddr   addr ;

   TransferParamters()
      : type( 'A' )
      , stru( 'F' )
      , mode( 'S' )
   {
   }

   TransferParamters( TransferParamters const& other )
      : type( other.type )
      , stru( other.stru )
      , mode( other.mode )
   {
      addr = TINETAddr( other.addr.port(), other.addr.getip()) ;
   }
};

namespace std 
{
   template<>
      struct less< TINETAddr >
      {
         bool operator()( TINETAddr const& addr1, TINETAddr const& addr2 ) const
         {
            if( addr1.getip() == addr2.getip())
               return addr1.port() < addr2.port() ;
            else 
               return addr1.getip() < addr2.getip() ;
         }
      };
}

inline bool operator==( TINETAddr const& addr1, TINETAddr const& addr2 )
{
   return ( addr1.getip() == addr2.getip()) && ( addr1.port() == addr2.port()) ;
}

inline bool operator!=( TINETAddr const& addr1, TINETAddr const& addr2 )
{
   return !( addr1 == addr2 ) ;
}