#pragma once 

interface iCommonTracer
{
   virtual void __stdcall Trace ( LPCWSTR msg ) = 0 ;
};

struct FileTracer
   : CComObjectRootEx< CComMultiThreadModel >
   , ITracer
{
   BEGIN_COM_MAP( FileTracer )
      COM_INTERFACE_ENTRY( ITracer )
   END_COM_MAP  ()

   void Init( LPCWSTR streamName, iCommonTracer* commonTracer )
   {
      USES_CONVERSION ;

      string name( L"Log\\" ) ;
      name += streamName ;

      file_      = fopen( W2A( name.c_str()), "w" ) ; 
      cmnTracer_ = commonTracer ;   
   }

   ~FileTracer()
   {
      cmnTracer_ = 0 ;
      if ( file_ ) 
         fclose( file_ ) ; 
   }

   // ITracer 
   void __stdcall Trace( LPCWSTR msg ) 
   {
      cmnTracer_->Trace( msg ) ;
      if ( file_ != 0 )
      {
         fwprintf( file_, msg   ) ;
         fwprintf( file_, L"\n" ) ;
         fflush  ( file_ ) ;
      }
   }

private:
   iCommonTracer* cmnTracer_ ;
   FILE*          file_ ;
};

struct TracerManager 
   : CComObjectRootEx< CComMultiThreadModel >
   , ITracerManager
{
   BEGIN_COM_MAP( TracerManager )
      COM_INTERFACE_ENTRY( ITracerManager )
   END_COM_MAP  ()

   void Init( iCommonTracer* commonTracer )
   {
      cmnTracer_ = commonTracer ;
   }

   // ITracerManager 
    ITracerPtr __stdcall CreateTracer( LPCWSTR name ) 
   {
      CComObject< FileTracer > * tracer = 0 ;
      CComObject< FileTracer >::CreateInstance( &tracer ) ;

      if ( tracer )
         tracer->Init( name, cmnTracer_ ) ; 
   
      return tracer ;
   }

private:
   iCommonTracer* cmnTracer_ ;
};