#include "stdafx.h"
#include "LinksHolder.h"
#include "MainWindow.h"

CMainWindow :: CMainWindow () 
{
   m_pServer.CreateInstance( __uuidof( CFTPServer )) ;
}

CMainWindow ::~CMainWindow () 
{
   m_pServer    = NULL ;
}


LRESULT CMainWindow :: OnInitDialog ( UINT, WPARAM, LPARAM, BOOL& )
{
   //-- list view 
   m_list.Attach( GetDlgItem( IDL_TRACE )) ;

   //-- creating the column 
   LVCOLUMN col = { 0 } ;
   col.mask = LVCF_WIDTH ;
   col.cx   = 400 ;

   m_list.InsertColumn( 0, &col ) ;

   return TRUE ;
}

LRESULT CMainWindow :: OnClose ( UINT, WPARAM, LPARAM, BOOL& )
{
   PostQuitMessage( 0 ) ;
   return 0;
}

LRESULT CMainWindow :: OnDestroy ( UINT, WPARAM, LPARAM, BOOL& )
{
   m_list.Detach() ;
   return 0;
}

LRESULT CMainWindow :: OnStartServer  ( WORD, WORD, HWND, BOOL& ) 
{
   CComObject< LinksProvider >* ptr ;
   CComObject< LinksProvider >::CreateInstance( &ptr ) ;
   ILinksProviderPtr provider = ptr ;
   
   CComObject< TracerManager > * mng ;
   CComObject< TracerManager >::CreateInstance( &mng ) ;

   if ( mng ) 
      mng->Init( this ) ; // be careful, manager shouldn't call Trace here

   m_pServer->StartServer( provider, mng ) ;

   return 0;
}

LRESULT CMainWindow :: OnStopServer  ( WORD, WORD, HWND, BOOL& ) 
{
   // TODO : make ability for force stop 
   m_pServer->StopServer( false ) ;

   return 0;
}

LRESULT CMainWindow :: OnExit        ( WORD, WORD, HWND, BOOL& ) 
{
   PostQuitMessage( 0 ) ;

   return 0;
}

void __stdcall CMainWindow :: Trace( LPCWSTR msg )
{
   m_list.InsertItem( m_list.GetItemCount(), msg );
}