#pragma once

#include "Interfaces.h"

struct ServersParser
{
   struct ServerAuthentication  
   {
      string user ;
      string pass ;
      
      ServerAuthentication() {}
      ServerAuthentication( LPCWSTR user, LPCWSTR pass )
         : user( user )
         , pass( pass )
      {
      }
   };

   typedef std::map < string, ServerAuthentication > ServerList ; // name & params 

   ServersParser( LPCSTR filename )  
   {
      USES_CONVERSION ;

      FILE* f = fopen( filename, "r" ) ;
      if( f != NULL )
      {
         char name [ MAX_PATH ] = "" ;
         char user [ MAX_PATH ] = "" ;
         char pass [ MAX_PATH ] = "" ;

         while ( fscanf( f, "%s %s %s", name, user, pass ) != EOF )
         {
            list_[ A2W( name ) ] = ServerAuthentication( A2W( user ), A2W( pass )) ;        
            user[ 0 ] = 0 ;
            pass[ 0 ] = 0 ;
         }
         
         fclose( f ) ;
      }
   }

   ServerList const& GetServerList() { return list_ ; }

private:
   ServerList list_ ;
};
